import 'package:geolocator/geolocator.dart';
import 'package:vegigo2_ui_common/error/messages.dart';
import 'package:vegigo2_ui_common/util/logger.dart';

abstract class LocationInfo {
  Future<Position> currentLocation();
}

class LocationInfoImpl implements LocationInfo {
  Future<Position> currentLocation() async {
    bool serviceEnabled = await Geolocator.isLocationServiceEnabled();
    if (!serviceEnabled) {
      logger.e(LOCATION_PERMISSION_ERROR);
      throw PermissionDeniedException(LOCATION_PERMISSION_ERROR);
    }
    return Geolocator.getCurrentPosition(desiredAccuracy: LocationAccuracy.high);
  }
}
